module GameOfGame

  class BasicPrisonner < RulesSet
    @cache = Hash(Ai, Float64).new
    @round : Round? = nil

    def examine(round : Round, player : Ai) : Float64
      if round != @round
        @cache.clear
        cheaters = round.bets.select { |_, bet| bet == 0.0 }.keys

        # nobody cheats, everyone wins 3 points
        if cheaters.empty?
          round.players.each { |player| @cache[player] = 3.0 }
        # someone cheated, they get all the points / cheaters amount
        # we dont add new points
        else
          round.players.each { |player| @cache[player] = 0.0 } # looser go 0
          distributed_points = round.players.size - cheaters.size
          points_by_cheater = distributed_points / cheaters.size.to_f64
          cheaters.each { |player| @cache[player] = points_by_cheater }
        end
      end

      examine_cache(player)
    end

    def examine_cache(player) : Float64
      @cache[player]
    end
  end

end
